%this code is provided as-is without any warranty or indemnification of any kind. 
%for any problem please contact me: e-mail adress: valedido@unina.it
%if you are using it please cite:
%Di Donato,V., Jamka. J., Martn-Fernndez J.A. 2020 - Compositional regression-based methods for SST reconstruction
%Alpine and Mediterranean Quaternary,... 

%ILR transformation of a compositional data matrix X based on a sequential binary partition. The formula is
%bj = ((rs/r+s)^1/2*)*ln(gm(x+)/gm(x-))
%where r and s are,respectively, the number of 1 and -1 of the row j of the partition. 
%gm(x+) is the geometric mean of the parts related to the 1, gm(x-) that of the parts related to -1.
%SPB has got as many rows of X and one less column

%calcola la ILR basandosi su una partizione binaria SBP della matrice dei
%dati X (SENZA colonna di intestazione). La formula 
%bj = ((rs/r+s)^1/2*)*ln(gm(x+)/gm(x?))
%in cui r ed s sono il numero di 1 e -1 della riga j della partizione. gm(x+)
% la media geometrica delle parti relative agli 1, gm(x-) la media geometrica delle parti relative agli -1.
%la matrice SPB ha le stesse righe di X ma una colonna in meno
%PSI  la matrice D-1 per D che serve a ottenere ILR=CLR*PSI' e  anche per
%l'inversa di ILR x=C(exp(ILR*PSI)

%esempio: [B,PSI]=balances(X,SBP)
function [B,PSI]=balances(X,SBP)
[n,p]=size(X);
[nn pp]=size(SBP);
%se non lo sono gi, trasforma i dati in proporzioni
for i=1:n
if sum(X(i,:))~=1
    X(i,:)=X(i,:)/sum(X(i,:));
end
end
B=zeros(n,p-1);
PSI=zeros(nn,pp);
%crea la matrice PSI
%per ogni riga di SPB
    for j=1:p-1
        X1=[];
        Xmeno1=[];
        %quanti 1 e quanti -1?
        find1=find(SBP(j,:)==1);
        findmeno1=find(SBP(j,:)==-1);
        %r e s sono i valori che appaiono nella formula dei balances
        [rr,r]=size(find1);
        [ss,s]=size(findmeno1);
        %ottiene riga per riga, PSI da SBP, per le celle in cui in SBP c'
        %1
        for z=1:r
            PSI(j,find1(z))=(1/r)*((r*s)/(r+s))^0.5;
        end
        %per le celle in cui c' -1 
        for z=1:s
            PSI(j,findmeno1(z))=-(1/s)*((r*s)/(r+s))^0.5;
        end
        %Non c' bisogno di considerare il caso in cui in SBP c' 0,
        %perch, la PSI allocata  fatta di zeri
%per ogni riga di X
for i=1:n
    %per ogni riga di SPB
    for j=1:p-1;
        X1=[];
        Xmeno1=[];
        %quanti 1 e quanti -1?
        find1=find(SBP(j,:)==1);
        findmeno1=find(SBP(j,:)==-1);
        %r e s sono i valori che appaiono nella formula dei balances
        [rr,r]=size(find1);
        [ss,s]=size(findmeno1);
        %ottiene riga per riga, PSI da SBP, per le celle in cui in SBP c'
        %1
        %for z=1:r
        %    PSI(j,find1(z))=(1/r)*((r*s)/(r+s))^0.5;
        %end
        %per le celle in cui c' -1 
        %for z=1:s
        %    PSI(j,findmeno1(z))=-(1/s)*((r*s)/(r+s))^0.5;
        %end
        %Non c' bisogno di considerare il caso in cui in SBP c' 0,
        %perch, la PSI allocata  fatta di zeri
        %per ogni colonna di SBP
        for k=1:p
            if SBP(j,k)==1
            X1=[X1 X(i,k)];
            Xmeno1=Xmeno1;
            elseif SBP(j,k)==-1
            Xmeno1=[Xmeno1 X(i,k)];
            X1=X1;
            elseif SBP(j,k)==0
            X1=X1;
            Xmeno1=Xmeno1;
            end
        end
        %calcola la media geometrica
        gm1= geomean(X1);
        gmmeno1=geomean(Xmeno1);
%         %passa ai logaritmi di X1 e Xmeno1
%         for z=1:r
%             logX1(z)=log(X1(z))
%         end
%         for z=1:s
%             logXmeno1(z)=log(Xmeno1(z))
%         end
%         %calcola il logaritmo delle medie geometriche gm1 e gm0
%         loggmmeno1=mean(logXmeno1)
%         loggm1=mean(logX1)
        %calcola il valore di B per la riga i e colonna j
        B(i,j)=sqrt(r*s/(r+s))*log(gm1/gmmeno1);
    end
  end
end