%this code is provided as-is without any warranty or indemnification of any kind. 
%for any problem please contact me: e-mail adress: valedido@unina.it
%if you are using it please cite:
%Di Donato,V., Jamka. J., Martn-Fernndez J.A. 2020 - Compositional regression-based methods for SST reconstruction
%Alpine and Mediterranean Quaternary,... 

%ILR tranformation obtained from a SBP matrix of the kind:
%  1 -1 -1 -1 
%  0  1 -1 -1
%  0  0  1 -1

%data is a compositional dataset without zeros
%PSI is the matrix to perform the inverse transformation

%trasformazione ILR ottenuta sequenzialmente da x1 a x(D-1), una contro
%tutte le altre. Restituisce anche la matrice PSI
%data  un set di dati composizionali, senza colonna di intestazionee
function [ilrprg4,PSI]=ilrprogr(data)
[N D]=size(data);
%se non lo sono gi, trasforma i dati in proporzioni
for i=1:N
if sum(data(i,:))~=1
    data(i,:)=data(i,:)/sum(data(i,:));
end
end
PSI=zeros(D-1,D);
%crea una matrice tipo balances progressiva
SBP=zeros(D-1,D);
for j=1:D
    for i=1:D
        if i==j
        SBP(i,j)=1;
        elseif i<j
        SBP(i,j)=-1;
        elseif i>j
        SBP(i,j)=0;
        end
    end
end
%e la usa per creare PSI
PSI=zeros(D-1,D);
%per ogni riga di SPB
    for j=1:D-1
        X1=[];
        Xmeno1=[];
        %quanti 1 e quanti -1?
        find1=find(SBP(j,:)==1);
        findmeno1=find(SBP(j,:)==-1);
        %r e s sono i valori che appaiono nella formula dei balances
        [rr,r]=size(find1);
        [ss,s]=size(findmeno1);
        %ottiene riga per riga, PSI da SBP, per le celle in cui in SBP c'
        %1
        for z=1:r
            PSI(j,find1(z))=(1/r)*((r*s)/(r+s))^0.5;
        end
        %per le celle in cui c' -1 
        for z=1:s
            PSI(j,findmeno1(z))=-(1/s)*((r*s)/(r+s))^0.5;
        end
        %Non c' bisogno di considerare il caso in cui in SBP c' 0,
        %perch, la PSI allocata  fatta di zeri
    end   
%chiude a 100 i dati (mai si sa..)
somma=sum(data,2) ;
for i=1:N
    data(i,:)=data(i,:)./somma(i,1);
end
%riga per ogni riga ilr
ilrprg=zeros(N,D-1);
for j=1:N
    for i=1:(D-1)
    ilrprg4(j,i)=((1*(D-i)/(1+(D-i)))^0.5)*log(data(j,i)/(prod(data(j,(i+1):D))^(1/(D-i))));
    end
end
% for j=1:N
%     for i=1:(D-1)
%     ilrprg(j,i)=((D-i/D-i+1)^0.5)*log(data(j,i)/(prod(data(j,(i+1):D))^(D-i)));
%     end
% end
% ilrprg2=zeros(N,D-1)
% for j=1:N
%     for i=1:(D-1)
%     ilrprg2(j,i)=((1/i*(i+1))^0.5)*log(geomean(data(j,1:i))/data(j,i+1));
%     end
% end
% ilrprg3 =zeros(N,D-1)
% for j=1:N
%     for i=1:(D-1)
%     ilrprg3(j,i)=(1/(i*(i+1))^0.5)*log(prod(data(j,1:i))/(data(j,i+1)^i));
%     end
% end
end   
    