%this code is provided as-is without any warranty or indemnification of any kind. 
%for any problem please contact me: e-mail adress: valedido@unina.it
%if you are using it please cite:
%Di Donato,V., Jamka. J., Martn-Fernndez J.A. 2020 - Compositional regression-based methods for SST reconstruction
%Alpine and Mediterranean Quaternary,... 

%Makes graphs of the distances between a fossil assemblage and the
%analogues. 
%Ds             is the output of the function mat
%sigle          is a 1 or 2 column matrix with the name of the fossil sample (it can be
%               the first column of F). 
%'num'          is facultative and select how many analogues are included. By default the graph plot 
%               the distances of all analogues
%example 1:     plotmat(Ds,sigle)          create graphs of the whole analogues for all the samples 
%examples 2:    plotmat(Ds(k,:),sigle(k,1),6)     just 1 graph for the observation k and 6 analogues 
%
function plotanalog=plotanalog(Ds,sigle,num)
[f m]=size(Ds);
[ff mm]=size(sigle)
for i=1:f;
if nargin==2;
    figure
    plot (Ds(i,:),'-*');
    axis([1 m -Inf Inf]);
    xlabel('modern analogs')
    ylabel('Aitchison distance')
    if mm==1
    text(1+0.1,max(Ds(i,1:num))-0.2,{sigle(i,1)},'FontSize',15)
    elseif mm==2
    text(1+0.1,max(Ds(i,1:num))-0.1,{'cm' sigle(i,1)},'FontSize',15)    
    text(1+1,max(Ds(i,1:num))-0.1,{'ka BP' sigle(i,2)},'FontSize',15) 
    end
    esportafig
    %REM set(gca,'XTick',1:100:m);
elseif nargin==3
    figure
    plot (Ds(i,1:num),'-*');
    axis([1 num -Inf Inf]);
    xlabel('modern analogs')
    ylabel('Aitchison distance')
        if mm==1
        text(1+0.1,max(Ds(i,1:num))-0.1,{sigle(i,1)},'FontSize',15)
        elseif mm==2
        text(1+0.1,max(Ds(i,1:num))-0.1,{'cm' sigle(i,1)},'FontSize',15)    
        text(1+1,max(Ds(i,1:num))-0.1,{'ka BP' sigle(i,2)},'FontSize',15) 
        end
    set(gca,'XTick',1:1:num);
    esportafig
end
end
