%this code is provided as-is without any warranty or indemnification of any kind. 
%for any problem please contact me: e-mail adress: valedido@unina.it
%if you are using it please cite:
%Di Donato,V., Jamka. J., Martn-Fernndez J.A. 2020 - Compositional regression-based methods for SST reconstruction
%Alpine and Mediterranean Quaternary,... 

%makes a plots, for core samples of the mean distances among a fossil assemblage and the
%selected modern analogs 
%meanD             is the outout of the mat code
%y_label           is a label for the y axis (i.e. 'age cal ka' of 'depth (cm)') 
%no analogs        is an output of the mat code
%distanzalimite    is an output of the mat code
%rotazione         can be 'vert' of 'oriz'. Makes a vertical or orizontal
%                  age axis
%example           plotmeanD(meanD,'age cal ka',noanalogs,distanzalimite,'vert');
function plotmeanD=plotmeanD(meanD,y_label,noanalogs,distanzalimite,rotazione)
%[f m]=size(meanD);
figure
subplot('position',[0.1 0.1 0.1 0.8])
plot(meanD(:,1),meanD(:,2),'-k');
    axis([0 ceil(max(meanD(:,1))) -Inf Inf]); 
    ylabel('mean distance');
    xlabel(y_label);
% figure
% plot(meanD(:,1),noanalogs(:,1),'ok');    
    if nargin==4
        set(gca,'XTickMode','auto','XMinorTick','on')
    elseif nargin==5
        switch rotazione
        case 'oriz'
        set(gca,'XTickMode','auto','XMinorTick','on')
        case 'vert'
        set(gca,'XTickMode','auto','XMinorTick','on','XAxisLocation','bottom','YAxisLocation','right','YMinorTick','on')
        view([90 90]) 
        end
    end
hold on
subplot('position',[0.1+0.15 0.1 0.1 0.8])
plot(meanD(:,1),noanalogs(:,1),'ok','MarkerSize',3);
axis([0 ceil(max(meanD(:,1))) -Inf Inf]); 
    ylabel('squared mahalanobis');
    xlabel(y_label);
hold on
if nargin==4
        set(gca,'XTickMode','auto','XMinorTick','on')
    elseif nargin==5
        switch rotazione
        case 'oriz'
        set(gca,'XTickMode','auto','XMinorTick','on')
        case 'vert'
        set(gca,'XTickMode','auto','XMinorTick','on','XAxisLocation','bottom','YAxisLocation','right','YMinorTick','on')
        view([90 90]) 
        end
    end
    plot([meanD(1,1) meanD(end,1)],[distanzalimite(1,1) distanzalimite(1,1)])
    set(gcf, 'units','centimeters','PaperPosition', [1 1 20 15]);
hold off
end
    %    set(gca,'XTick',0:2:ceil(max(meanD(:,1))));
    