%this code is provided as-is without any warranty or indemnification of any kind. 
%for any problem please contact me: e-mail adress: valedido@unina.it
%if you are using it please cite:
%Di Donato,V., Jamka. J., Martn-Fernndez J.A. 2020 - Compositional regression-based methods for SST reconstruction
%Alpine and Mediterranean Quaternary,...

%makes scatter graphs of a fossil samples together with the closest
%                   analogs, obtained as in mat, within the axis 1 and 2 plane 
%                   of the relative variation biplot computed for the modern database.
%the fossil is considered as a supplementary data.
%Modern             is the modern dataset (N.B. only the assemblages, without enviromental data and ID of the samples)
%Fossil             is the "fossil" assemblages dataset (Without the first column with ages or depth!)
%dist               is the adopted distance ('euclidean','mahalanobis'), 
%subdist            can be 'soloPC' or 'totale'. With 'totale' the distances are computed
%                   on the full dimensionality. With 'soloPC' the distances are computed only
%                   within the spase defined by the first axes of the biplot (which are less to equal to the previous)
%'num'              must be at least 10, indicates how many modern analogs are included
%dueotre            can be 'dueD' (2D biplot) or 'treD' (3D biplot)

%example scatteranalog(Modern,Fossil,'euclidean','soloPC',10,'dueD')
%example2: [I,FModern,FFossil]=scatteranalog(Modern,Fossil,'euclidean','soloPC',10,'dueD')

%i grafici a scatter dei primi analoghi insieme al campione fossile (uno o pi), 
%nei piani asse 1 e 2 del form biplot calcolato per il database moderno
%delle distanze dagli analoghi per tutti i campioni fossili.
%dist  la distanza utilizzata (vedi MAT)
%subdist pu essere 'soloPC' o 'totale' a seconda che le distanze siano
     %riferite solo alle componenti principali o sull'intera
     %dimensionalit
%'num'  minimo 10, indica quanti modern plottare per ogni fossile
%dueotre pu essere: dueD o treD
%si plottano le distanze di 10 analoghi del database
%RIMOSSO Digitando: scatteranalog(M,FModern,param,Ds,sigle,num)          si creano i grafici per tutte le osservazioni 
%RIMOSSO Digitando: scatteranalog(M,FModern,param,Ds(k,:),sigle,num)     si crea solo il grafico per la sola osservazione k
%sigle pu essere 1 o 2 colonne
%N.B. bisogna inserire solo i dati, senza colonna di intestazione, anche per
%MOD solo la parte del database con le associazioni!!!!!
function [I,FModern,FFossil]=scatteranalog(Modern,Fossil,dist,subdist,num,dueotre)
%[f,m]=size(Ds);
%[ff,mm]=size(sigle);
[n,p]=size(Modern);
[nf,pf]=size(Fossil);
 %innanzitutto, come per Vbiplot, fa la decomposizione in valori singolari
%dei dati moderni
%colonne centrate
    for j=1:p
    ModernC(:,j)=Modern(:,j)-mean(Modern(:,j));
    end
%decomposizione in valori singolari dei dati moderni
    [UU,SS,VV]=svd(ModernC,0);
    %considera solo le prime 3 dimensioni (assume rango 3)
    L=trace(SS.^2);
    S=SS(1:3,1:3);
    V=VV(:,1:3);
    U=UU(:,1:3);
    %varianza tenuta in conto
    inf1=(SS(1,1)^2)*100/L;
    inf2=(SS(2,2)^2)*100/L;
    inf3=(SS(3,3)^2)*100/L;
    inftot=inf1+inf2+inf3;
    I=[inf1 inf2 inf3 inftot];
%procede per form biplot
%carichi
A=V;
%punteggi
FModern=U*S;
%fattorizza anche l'associazione fossile (come in Vbiplotadd)
%1 Centra le colonne rispetto alle medie dei dati moderni (se i dati sono CLR le righe sono gi centrate)
    Fossil2=zeros(nf,pf);
    for j=1:pf
    Fossil2(:,j)=Fossil(:,j)-mean(Modern(:,j));
    end
%2 fattorizza
FFossil=Fossil2*A;

switch subdist
    case 'totale'
    %crea la matrice per il calcolo delle distanze tra righe di FModern e righe di M 
    D=zeros(nf,n);
    %calcola la matrice delle distanze utilizzando diverse distanze
    switch dist
        case 'costheta'
            for i=1:nf
                for j=1:n
                D(i,j)=(sum((Fossil(i,:)).*(Modern(j,:))))/(sqrt(sum((Fossil(i,:).^2)).*(sum(Modern(j,:).^2))));
                end    
            end
        case 'euclidean'
            for i=1:nf 
                for j=1:n
                diff=(Fossil(i,:)-Modern(j,:));
                sq=diff.^2;
                D(i,j)=sqrt(sum(sq')');
                end    
            end
        case 'squared euclidean' 
            for i=1:nf
                for j=1:n
    diff=(Fossil(i,:)-Modern(j,:));
    sq=diff.^2;
    D(i,j)=sum(sq')';
                end    
            end
        case 'mahalanobis'
                iM=[Modern(:,:)];
                IM=pinv(cov(iM));
                for i=1:nf
                     for j=1:n
                     D(i,j)=sqrt((Fossil(i,:)-Modern(j,:))*IM*(FModern(i,2:end)-Modern(j,:))'); 
                     end
                end        
        case 'sqchord'
            for i=1:nf
                for j=1:n
                diff=(sqrt(Fossil(i,:)))-(sqrt(Modern(j,:)));  
                sq=diff.^2;
                D(i,j)=sum(sq')';
                end
            end
       end      
    %ordina in senso ascendente ciascuna riga (Ds) e mostra la permutazione effettuata (IX)
    [Ds,IXFoss]=sort(D,2);
     %poich 'costheta'  un coefficiente di similarit, ruota da dx a sn le matrici Ds e IX  
    switch dist
        case 'costheta'
        Ds=fliplr(Ds);
        IXFoss=fliplr(IXFoss);
    otherwise 
    end
    
    case 'soloPC'
    %crea la matrice per il calcolo delle distanze tra righe di FModern e righe di M 
    D=zeros(nf,n);
    %calcola la matrice delle distanze utilizzando diverse distanze
    switch dist;
        case 'costheta'
            for i=1:nf
                for j=1:n
                D(i,j)=(sum((FFossil(i,:)).*(FModern(j,:))))/(sqrt(sum((FFossil(i,:).^2)).*(sum(FModern(j,:).^2))));
                end    
            end
        case 'euclidean'
            for i=1:nf 
                for j=1:n
                diff=(FFossil(i,:)-FModern(j,:));
                sq=diff.^2;
                D(i,j)=sqrt(sum(sq')');
                end    
            end
        case 'squared euclidean' 
            for i=1:nf
                for j=1:n
    diff=(FFossil(i,:)-FModern(j,:));
    sq=diff.^2;
    D(i,j)=sum(sq')';
                end    
            end
        case 'mahalanobis'
                iM=[FModern(:,:)];
                IM=pinv(cov(iM));
                for i=1:nf
                     for j=1:n
                     D(i,j)=sqrt((FFossil(i,:)-FModern(j,:))*IM*(FModern(i,2:end)-FModern(j,:))'); 
                     end
                end        
        case 'sqchord'
            for i=1:nf
                for j=1:n
                diff=(sqrt(FFossil(i,:)))-(sqrt(FModern(j,:)));  
                sq=diff.^2;
                D(i,j)=sum(sq')';
                end
            end
       end      
    %ordina in senso ascendente ciascuna riga (Ds) e mostra la permutazione effettuata (IX)
    [Ds,IXFoss] = sort(D,2);
     %poich 'costheta'  un coefficiente di similarit, ruota da dx a sn le matrici Ds e IX  
    switch dist
        case 'costheta'
        Ds=fliplr(Ds);
        IXFoss=fliplr(IXFoss);
    otherwise 
    end    
end

%ruota IXFoss in modo che sia una colonna
IXFoss=IXFoss';

switch dueotre
    case 'dueD'
    %genera la/e figure: inserisce le osservazioni (i primi analoghi) rossi i primi 6, gialli a 7 a 10, verdi da 11 a seguire
    for i=1:nf
    figure
    scatter(FModern(IXFoss(1:6,i),1),FModern(IXFoss(1:6,i),2),6,'r')
    box on
    hold on
    scatter(FModern(IXFoss(7:10,i),1),FModern(IXFoss(7:10,i),2),6,'y')
    if num>10
    scatter(FModern(IXFoss(11:num,i),1),FModern(IXFoss(11:num,i),2),6,'g')
    else
    end
    scatter(FFossil(i,1),FFossil(i,2),60,'*k')
    %inserisce le etichette delle osservazioni
    run=[1:num]';
    obs=num2cell(IXFoss(1:num,i));
    obs2=num2cell(run(1:num,1));
    %for b=1:num
    text(FModern(IXFoss(1:num,i),1)+0.05,FModern(IXFoss(1:num,i),2)+0.05,obs(1:num,1),'FontSize',5,'color','k','Fontname','Arial');
    text(FModern(IXFoss(1:num,i),1)+0.05,FModern(IXFoss(1:num,i),2)-0.05,obs2(1:num,1),'FontSize',5,'color','k','Fontname','Arial')
    %end
    %aggiunge cerchi di raggio 1 2 e 3
    t = linspace(0,2*pi);
    plot(cos(t)+FFossil(i,1),sin(t)+FFossil(i,2),'k');
    plot(cos(t)*2+FFossil(i,1),sin(t)*2+FFossil(i,2),'k');
    plot(cos(t)*3+FFossil(i,1),sin(t)*3+FFossil(i,2),'k');
    set(gca,'DataAspectRatio',[3 3 1])	
    xlabel('Axis 1')
    ylabel('Axis 2')
    hold off
    end
    
    case 'treD'
    %genera la/e figurr
    for i=1:nf
    figure
    scatter3(FModern(IXFoss(1:6,1),1),FModern(IXFoss(1:6,1),2),FModern(IXFoss(1:6,1),3),6,'r');
    hold on
    scatter3(FModern(IXFoss(7:10,1),1),FModern(IXFoss(7:10,1),2),FModern(IXFoss(7:10,1),3),6,'y');
    if num>10
    scatter3(FModern(IXFoss(11:num,1),1),FModern(IXFoss(11:num,1),2),FModern(IXFoss(11:num,1),3),6,'g');
    else
    end    
    scatter3(FFossil(1,1),FFossil(1,2),FFossil(1,3),60,'*k')
    %inserisce le etichette delle osservaz,ioni
    run=[1:n]';
    obs=num2cell(IXFoss(1:num,1));
    obs2=num2cell(run(1:num,1));
    text(FModern(IXFoss(1:num,1),1)+0.05,FModern(IXFoss(1:num,1),2),FModern(IXFoss(1:num,1),3)+0.05,obs(1:num,1),'FontSize',8,'color','k','Fontname','Arial');
    text(FModern(IXFoss(1:num,1),1)+0.05,FModern(IXFoss(1:num,1),2),FModern(IXFoss(1:num,1),3)-0.05,obs2(1:num,1),'FontSize',8,'color','k','Fontname','Arial');
    xlabel('Axis 1')
    ylabel('Axis 2')
    zlabel('Axis 3')
    hold off
    end
 end
 
% scatter(FModern(:,1),FModern(:,2),6,'g')
% 
% 
% for i=1:f;
% if nargin==2;
%     figure
%     plot (Ds(i,:),'-*');
%     axis([1 m -Inf Inf]);
%     xlabel('modern analogs')
%     ylabel('Aitchison distance')
%     if mm==1
%     text(1+0.1,max(Ds(i,1:num))-0.2,{sigle(i,1)},'FontSize',15)
%     elseif mm==2
%     text(1+0.1,max(Ds(i,1:num))-0.1,{'cm' sigle(i,1)},'FontSize',15)    
%     text(1+1,max(Ds(i,1:num))-0.1,{'ka BP' sigle(i,2)},'FontSize',15) 
%     end
%     esportafig
%     %REM set(gca,'XTick',1:100:m);
% elseif nargin==3
%     figure
%     plot (Ds(i,1:num),'-*');
%     axis([1 num -Inf Inf]);
%     xlabel('modern analogs')
%     ylabel('Aitchison distance')
%         if mm==1
%         text(1+0.1,max(Ds(i,1:num))-0.1,{sigle(i,1)},'FontSize',15)
%         elseif mm==2
%         text(1+0.1,max(Ds(i,1:num))-0.1,{'cm' sigle(i,1)},'FontSize',15)    
%         text(1+1,max(Ds(i,1:num))-0.1,{'ka BP' sigle(i,2)},'FontSize',15) 
%         end
%     set(gca,'XTick',1:1:num);
%     esportafig
% end
end
