%this code is provided as-is without any warranty or indemnification of any kind. 
%for any problem please contact me: e-mail adress: valedido@unina.it
%if you are using it please cite:
%Di Donato,V., Jamka. J., Martn-Fernndez J.A. 2020 - Compositional regression-based methods for SST reconstruction
%Alpine and Mediterranean Quaternary,... 

%this function amalgamates a data matrix on the basis of the
%matriceperraggruppare matrix
%matriceperraggruppare is a matrix of the kind
%1 2 3 4 6 8  
%0 5 0 0 7 0
%0 9 0 0 0 0
%In this example, columns 2, 5 and 9 are amalgamated, as well as columns 6
%and 7. Columns 1, 3, 4 and 8 are left as they are
%
%raggruppati is the amalgamated matrix
%
%if a third argument "testo", including a text string related to the "dati"
%matrix, is added, "testoraggruppato" is a text string with the
%corresponding amalgamated groups (remember to give a name to the
%amalgamated groups)
%examples:
%amalgamated=raggruppa(data,matriceperraggruppare)
%[amalgamated,textamalgamated]=raggruppa(data,matriceperraggruppare,textdata)

%sulla base della matrice dei dati, crea la matrice raggruppati, utilizzando una seconda matrice in cui ogni colonna
%rappresenta le colonne da raggruppare (cio in ogni colonna sono inserite le celle delle colonne
%della matrice "testo" che si vuole siano raggruppate)
%raggruppa anche i testi corrispondenti, utilizzando il primo elemento di ogni 
%colonna per attribuire il testo
%testorappruppato a sinistra si mette solo se c' testo a destra 
function [raggruppati,testoraggruppato]=raggruppa(dati,matriceperraggruppare,testo)
[n p]=size(dati);
[nn pp]=size(matriceperraggruppare);
raggruppati=zeros(n,pp);
testoraggruppato={zeros(1,pp)};
%lavora su ogni colonna di matriceperraggruppare
for i=1:pp
    %crea una colonna di lavoro, in modo da selezionare i valori non nulli
    %per tutte le colonne
    %elemento 1,1
    colonna=matriceperraggruppare(1,i);
    %poi scende lungo la colonna
        for j=2:nn
            if matriceperraggruppare(j,i)~=0;
            colonna=[colonna
            matriceperraggruppare(j,i)];
            else
            end
        end
    [nnn ppp]=size(colonna);
    %crea la matrice dei dati sommati, primo elementi
    raggruppati(:,i)=dati(:,colonna(1,1));
    %se la colonna ha pi elementi somma
    if nnn>1
        for k=2:nnn
        raggruppati(:,i)=raggruppati(:,i)+dati(:,colonna(k,1));
        end
    else
    end    
end
if nargin==3
%seleziona gli elementi della matrice di testoraggruppato sulla base di
%testo e matrice per raggrupare
for j=1:pp
    for i=1:nn
        if matriceperraggruppare(i,j)~=0;
        testoraggruppato(i,j)=testo(1,matriceperraggruppare(i,j));
        else
        end
    end
end
end
end